//----------------------------------------------------------------------
// Definitions for the handler function registration/access routines.
//
// NOTE: The following routines are based on an older design that used
// a 'core' interface and these C++ functions as wrappers around that
// core.  This design has since been changed to use polymorphic 'controllers'
// for the core functionality, and these routines have NOT been updated to
// that new design.  They are here for historical reference.  Because
// of this, they are disabled with an #if 0 / #endif block.
//
//----------------------------------------------------------------------

#if 0

//----------------------------------------------------------------------
// Include Files
//----------------------------------------------------------------------

#include "cheetah_register_handler.h"
#include <vector>
#include <assert.h>

//----------------------------------------------------------------------
//
// We store a vector of the registered handlers.
// The tag for each handler is the offset in the vector.
//
//----------------------------------------------------------------------

static std::vector<cheetah_handler_t> *handlers_s=0;


//----------------------------------------------------------------------
//
// cheetah_register_handler
//
// Each new handler just goes on the end of the vector of handlers.
//
//----------------------------------------------------------------------

int cheetah_register_handler( cheetah_handler_t handler )
{
  if ( handlers_s == 0 )
    handlers_s = new std::vector<cheetah_handler_t>;

  handlers_s->push_back( handler );
  return handlers_s->size() - 1;
}


//----------------------------------------------------------------------
//
// cheetah_get_registered_handler
//
// Just look up the handler in the vector.
//
//----------------------------------------------------------------------

cheetah_handler_t cheetah_get_registered_handler( int tag )
{
  if ( (handlers_s==0) || (tag < 0) || (tag >= handlers_s->size()) )
    return 0;
  return (*handlers_s)[tag];
}


//----------------------------------------------------------------------

#endif   // #if 0
