#ifndef CHEETAH_CORE_REGISTERHANDLER_H
#define CHEETAH_CORE_REGISTERHANDLER_H

//----------------------------------------------------------------------
//
// Handler function registration/access routines, with C bindings.
//
// NOTE: The following routines are based on an older design that used
// a 'core' interface and these C++ functions as wrappers around that
// core.  This design has since been changed to use polymorphic 'controllers'
// for the core functionality, and these routines have NOT been updated to
// that new design.  They are here for historical reference.  Because
// of this, they are disabled with an #if 0 / #endif block.
//
//----------------------------------------------------------------------

#if 0

#ifdef __cplusplus
extern "C"
{
#endif

  /*
  // The function type for a user handler function.  It tells the
  // handler what context sent the request, the data it sent and the
  // length (in bytes) of the data.  No translation of the data is
  // performed in the communication.
  */

  typedef void (*cheetah_handler_t)(int who, int tag, void* buf,int len);

  /*
  // Register a function so that a remote process can call it.
  // Returns a unique tag for the function.
  // The same function may be registered multiple times, and a 
  // unique tag is returned each time.
  // The remote process will use the provided tag to indicate the function.
  */

  int cheetah_register_handler( cheetah_handler_t handler );

  /*
  // Get the handler for a particular tag.
  // This is a fast (constant time) lookup.
  */

  cheetah_handler_t cheetah_get_registered_handler( int tag );

#ifdef __cplusplus
}
#endif

#endif   // #if 0

#endif // CHEETAH_CORE_REGISTERHANDLER_H
