//-----------------------------------------------------------------------------
//
// SpinlockMutex method definitions
//
//-----------------------------------------------------------------------------

#include "CheetahConfiguration.h"
#include "Utilities/CheetahSpinlockMutex.h"
#include <unistd.h>

#if !defined(CHEETAH_SINGLETHREADED)
#include <sched.h>
#endif

namespace Cheetah {

SpinlockMutex::SpinlockMutex()
  : slock(0)
{
}


void SpinlockMutex::unlock()
{
  slock = 0;
}


void SpinlockMutex::lock()
{
#if ! defined(CHEETAH_SINGLETHREADED)
#if defined(CHEETAH_UNIPROCESSOR)
  while (!trylock())
    sched_yield();
#else
  spinlock(&slock,1);
#endif
#endif // CHEETAH_SINGLETHREADED
}


int SpinlockMutex::trylock()
{
#if defined(CHEETAH_SINGLETHREADED)
  return 1;
#else
  return spintrylock(&slock,1);
#endif // CHEETAH_SINGLETHREADED
}


} // namespace Cheetah
